/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.parser.gringo;

import aspmodificator.model.LineBase;

public class ConstDefinition extends LineBase {

	private String identifier;
	private Term term;

	public ConstDefinition(String id, Term term) {
		this.identifier = id;
		this.term = term;
	}

	public ConstDefinition(String id, Term term, int lineNo) {
		super(lineNo);
		this.identifier = id;
		this.term = term;
	}

	@Override
	public Object clone() throws CloneNotSupportedException {
		return new ConstDefinition(new String(identifier), (Term) term.clone());
	}

	@Override
	public String toOutputString() {
		return toString();
	}

	@Override
	public String toString() {
		return "#const " + identifier.toString() + " = " + term.toString()
				+ ".";
	}

}
