/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.parser.gringo;

import java.util.ArrayList;
import java.util.List;

public class RangeTerm extends Term {

	// private Term lowerRange;
	// private Term upperRange;
	protected RangeTerm() {
		super();
	}

	public RangeTerm(Term a, Term b) {
		super("..");
		List<Literal> tmpList = new ArrayList<Literal>();
		tmpList.add(a);
		tmpList.add(b);
		this.setTerms(tmpList);
	}

	public RangeTerm(Term a, Term b, int pos) {
		super("..", pos);
		List<Literal> tmpList = new ArrayList<Literal>();
		tmpList.add(a);
		tmpList.add(b);
		this.setTerms(tmpList);
	}

	public Term getLowerRange() {
		return (Term) getTerms().get(0);
	}

	public Term getUpperRange() {
		return (Term) getTerms().get(1);
	}

	public void setLowerRange(Term lowerRange) {
		getTerms().remove(0);
		getTerms().add(0, lowerRange);
	}

	public void setUpperRange(Term upperRange) {
		getTerms().remove(1);
		getTerms().add(1, upperRange);
	}

	@Override
	public String toString() {
		return getTerms().get(0).toString() + ".."
				+ getTerms().get(1).toString();
	}

}
