/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
/**
 * 
 */
package common;

/**
 * Class for connecting two Objects to a pair.
 * 
 * @author Martin
 * @version 1.0
 * 
 */
public class Pair<T, K> implements Comparable<Pair<T, K>> {

	protected T First;
	protected K Second;

	public Pair(T f, K s) {
		First = f;
		Second = s;
	}

	@Override
	public int compareTo(Pair<T, K> o) {
		return o.toString().compareTo(this.toString());
	}

	/**
	 * @return the first
	 */
	public T getFirst() {
		return First;
	}

	/**
	 * @return the second
	 */
	public K getSecond() {
		return Second;
	}

	/**
	 * @param first
	 *            the first to set
	 */
	public void setFirst(T first) {
		First = first;
	}

	/**
	 * @param second
	 *            the second to set
	 */
	public void setSecond(K second) {
		Second = second;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "(" + First + "," + Second + ")";
	}

}
