/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package main;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.PrintStream;
import static org.junit.Assert.*;

import org.apache.log4j.Level;
import org.junit.After;
import org.junit.Before;

import static org.hamcrest.core.Is.is;

public class SystemTests {

	private ByteArrayOutputStream outputStream;

	@Before
	public void setUp() throws Exception {
		outputStream = new ByteArrayOutputStream();
		System.setOut(new PrintStream(outputStream));
	}

	@After
	public void tearDown() throws Exception {
		System.setOut(null);
	}

	// @Test
	public void testMain() {
		String[] args = { "-configFile",
				"test" + File.separator + "testConfigFile.xml", "-inputFile",
				"test" + File.separator + "sudoku_decision.gringo",
				"-outputDir", "test", "-logging", Level.ALL.toString() };
		Main.main(args);

		File resultFile1 = new File("." + File.separator + "test"
				+ File.separator + "sudoku_decision_mod0.gringo");
		assertThat(resultFile1.exists(), is(true));

		// resultFile1.delete();
	}

	// @Test
	public void testMain_bugFixTest_1() {
		String[] args = { "-configFile",
				"test" + File.separator + "testConfigFile.xml", "-inputFile",
				"test" + File.separator + "test.gringo", "-outputDir", "test",
				"-logging", Level.ALL.toString() };
		Main.main(args);
	}

	// @Test
	public void testMain_bugFixTest_2() {
		String[] args = { "-configFile",
				"test" + File.separator + "testConfigFile.xml", "-i",
				"test" + File.separator + "maze-reference_ground.gringo",
				"-outputDir", "test", "-logging", Level.ALL.toString() };
		Main.main(args);
	}

	// @Test
	public void testMain_bugFixTest_3() {

		String[] args = { "-configFile",
				"test" + File.separator + "atom_replaced_100mutants.xml", "-i",
				"test" + File.separator + "reference-no-externals.gringo",
				"-outputDir", "test", "-logging", Level.ALL.toString() };
		Main.main(args);

	}

	// @Test
	public void testMain_bugFixTest_4() {

		String[] args = { "-configFile",
				"test" + File.separator + "atom_replaced_100mutants.xml", "-i",
				"test" + File.separator + "reference.gringo", "-outputDir",
				"test", "-logging", Level.ALL.toString() };
		Main.main(args);
	}

	// @Test
	public void testMain_bugFixTest_5() {

		String[] args = { "-configFile",
				"test" + File.separator + "atom_replaced_100mutants.xml", "-i",
				"test" + File.separator + "sokobanDecision.gringo",
				"-outputDir", "test", "-logging", Level.ALL.toString() };
		Main.main(args);
	}

	// @Test
	public void testMain_bugFixTest_6() {

		String[] args = { "-configFile",
				"test" + File.separator + "atom_replaced_100mutants.xml", "-i",
				"test" + File.separator + "sokobanDecision.gringo",
				"-outputDir", "test", "-logging", Level.ALL.toString() };
		Main.main(args);
	}

	// @Test
	public void testMain_bugFixTest_7() {

		String[] args = { "-configFile",
				"test" + File.separator + "config.xml", "-i",
				"test" + File.separator + "magic_square.gringo", "-outputDir",
				"test", "-logging", Level.ALL.toString() };
		Main.main(args);
	}
}
